<?php

require_once(dirname(__DIR__, 3).'/config/config.inc.php');
require(dirname(__DIR__).'/classes/API/TetOnline.php');

function exportAction($id_order)
{
    if ((trim(Configuration::get('TETONLINE_API_URL')) == '') || (trim(Configuration::get('TETONLINE_API_KEY')) == ''))
    {
        echo json_encode(array('msg'=> 'É necessário configurar a chave e/ou o url da API do TetOnline.'));
        return;
    }

    $tet = new TetOnline();
    $company = $tet->getCompany();

    if (($company->success !== true))
	{
		echo json_encode(array('msg'=> 'Não foi possivel fazer ligação ao programa de faturação.'));
        return;
	}
	
    echo $tet->generateInvoice($id_order);
    return;
}

function pdf_page($order_id)
{
    $tet = new TetOnline();
    $order = new Order($order_id);
    $document = Db::getInstance()->getRow('SELECT `_tetonline_document_id`
        FROM `'._DB_PREFIX_.'orders`
        WHERE `id_order` = \''.pSQL($order->id).'\'');

    if (trim($document['_tetonline_document_id']) != '')
    {
        $tetonline_document_ids = explode('_',$document['_tetonline_document_id']);
        
        $gen_doc = $tet->generateDocPdf($tetonline_document_ids[0], $tetonline_document_ids[1]);
	
		if ($gen_doc->success === true)
		{
			if ($gen_doc->multiple_files) 
			{
				$p = $gen_doc->id[0];
			}
			else
			{
				$p = $gen_doc;
			}
			
			if (((int)$tet->emaildocument === 1) && ((int)$tetonline_document_ids[2] !== 0))
			{
				$template = $tet->getEmailTemplates((int)$tetonline_document_ids[2], $tetonline_document_ids[0]);
				if ($template->success === true)
				{
					$tet->sendDocEmail(array('docID'=>$tetonline_document_ids[0], 'templateID'=> $template->templates[0]->ID));
				}
			}

			$result = $tet->getDocPdf($p->id, $p->name);
			if ($result) {
				if (file_exists($p->name.'.pdf'))
				{
					unlink($p->name.'.pdf');
				}
				file_put_contents($p->name.'.pdf', $result);
				
                header("Expires: 0");
				header("Cache-Control: no-cache, no-store, must-revalidate"); 
				header('Cache-Control: pre-check=0, post-check=0, max-age=0', false); 
				header("Pragma: no-cache");	
				header("Content-type: application/pdf");
				header('Content-Disposition: attachment; filename="'.$p->name.'.pdf"');
				header("Content-Type: application/force-download");

				ob_clean();
				flush();
				readfile($p->name.'.pdf');
                if (file_exists($p->name.'.pdf'))
				{
					unlink($p->name.'.pdf');
				}
            }
        }
    }
	exit();
}

$req = $_POST;
$action = $req['action'];
$id_order = $req['order_id'];

switch ($action) 
{
    case 'export_document': 
    {
        echo exportAction($id_order);
        break;
    }
    case 'generate_pdf':
    {
        pdf_page($id_order);
        break;
    }
    default: break;
}