(function($) {
    $(window).load(function() {
        $("#import-products-tetonline").click(function(){
            $("#result").html('');
            var spin = $('#tetonline_wait_process_products');
            var btn = $(this);
            btn.prop('disabled',true);
            spin.prop('hidden', false);
            $.ajax({
                url: '../modules/tetonline/classes/Import.php',
                data: {
                    action: "import_products",
                },
                dataType: "json",
                method: "POST",
                success: function (response) {
                    if (response) 
                    {
                        $('#result').html(response.msg);
                    }
                },
                error: function (errorThrown) {
                    console.log(errorThrown);
                },
                complete: function()
                {
                    btn.prop('disabled', false);
                    spin.prop('hidden', true);
                }
            });
        });
        $("#export-document-tetonline").click(function() {
            var res = $("#tetonline_result_exp")
            var btn = $(this);
            var spin = $('#tetonline_wait_process_docs');
            btn.prop('disabled', true);
            spin.prop('hidden', false);
            res.html('');
            $.ajax({
                url: '../../../../../modules/tetonline/classes/Export.php',
                data: {
                    action: "export_document",
                    order_id: $('#tetonline_order_id').html()
                },
                dataType: "json",
                method: "POST",
                success: function (response) {
                    if (response) 
                    {
                        res.html(response.msg);
                    }
                },
                error: function (errorThrown) {
                    console.log(errorThrown);
                },
                complete: function()
                {
                    btn.prop('disabled', false);
                    spin.prop('hidden', true);
                }
            });
        });
        $("#pdf-document-tetonline").click(function() {
            var btn = $(this);
            var spin = $('#tetonline_wait_download_pdf');
            btn.prop('disabled', true);
            spin.prop('hidden', false);
            $.ajax({
                url: '../../../../../modules/tetonline/classes/Export.php',
                data: {
                    action: "generate_pdf",
                    order_id: $('#tetonline_order_id').html()
                },
                xhrFields: {
                    responseType: 'blob'
                },
                method: "POST",
                success: function (response, status, xhr) {
                    if (response) 
                    {
                        let disposition = xhr.getResponseHeader('Content-Disposition');
                        let filename = disposition.split('filename=')[1];
                        filename = filename.split('.pdf');
                        let a = document.createElement('a');
                        let url = window.URL.createObjectURL(response);
                        a.href = url;
                        a.download = filename[0]+'.pdf';
                        document.body.append(a);
                        a.click();
                        a.remove();
                        window.URL.revokeObjectURL(url);
                    }
                },
                error: function (errorThrown) {
                    console.log(errorThrown);
                },
                complete: function()
                {
                    btn.prop('disabled', false);
                    spin.prop('hidden', true);
                }
            });
        });
    });
})(jQuery);